/** Symulacja lotu piki ze szczytu Paacu Kultury i Nauki.
 *  Program wywietla wysoko, na ktrej znajduje si pika
 *  w kolejnych sekundach lotu
 *
 * Kody zaczerpniete z polskiej edycji        *
 * ksiazki Serwisy internetowe. Programowanie *
 * Wydawnictwo Helion, Gliwice,               *
 * ftp://ftp.helion.pl/przyklady/serinp.zip   *
 * &copy; 2001 Marty Hall and Larry Brown;    *
 */

public class LotPilki {
  public static void main(String[] argumenty) {
    int czas = 0;
    double szczyt = 230.0, pokonanaWysokosc = 0.0;
    double wysokosc = szczyt;
    while (wysokosc > 0) {
      System.out.println("Po upywie " + czas + 
                   (czas==1 ? " sekundy " : " sekund ") + 
                   "pika znajduje si na wysokoci " + wysokosc + " metrw.");
      czas++;                   
      pokonanaWysokosc = swobodnySpadek(czas);
      wysokosc = szczyt - pokonanaWysokosc;
    }
    System.out.println("Pika upada na ziemi przed upywem " + czas + " sekund");
  }
  
  /** Obliczenie wysokoci obiektu w trakcie spadku swobodnego
  */

  public static double swobodnySpadek(float czas) {
    // Staa grawitacyjna wynosi 10 metrw na sekund kwadrat
    return(5 * czas * czas); // 1/2 gt^2
  }
}